#!/usr/bin/env python
# -*- coding: utf-8 -*-
#######################################################################
# maintainer: einfall
#This plugin is free software, you are allowed to
#modify it (if you keep the license),
#but you are not allowed to distribute/publish
#it without source code (this version and your modifications).
#This means you also have to distribute
#source code of your modifications.
#######################################################################

from Components.ActionMap import *
from Components.ServiceEventTracker import ServiceEventTracker
from Components.Button import Button
from Components.Label import Label
from Components.ScrollLabel import ScrollLabel
from Components.ConfigList import ConfigListScreen
from Components.Sources.StaticText import StaticText
from Components.ActionMap import NumberActionMap, ActionMap
from Components.config import config, ConfigSelection, getConfigListEntry, ConfigText, ConfigInteger, ConfigDirectory, ConfigYesNo, ConfigSelection, ConfigSubsection, ConfigPIN, configfile
from Components.FileList import FileList, FileEntryComponent
from Components.GUIComponent import GUIComponent
from Components.MenuList import MenuList
from Components.Pixmap import Pixmap, MovingPixmap
from Components.PluginList import PluginEntryComponent, PluginList
from Components.AVSwitch import AVSwitch
from Components.MultiContent import MultiContentEntryText, MultiContentEntryPixmap, MultiContentEntryPixmapAlphaTest
from Components.ServiceEventTracker import ServiceEventTracker

from Plugins.Plugin import PluginDescriptor
from Screens.InfoBar import MoviePlayer
from Screens.HelpMenu import HelpableScreen
from Screens.MessageBox import MessageBox
from Screens.Screen import Screen
from enigma import iPlayableService, iServiceInformation, eServiceReference, eTimer
from enigma import gFont, eTimer, eConsoleAppContainer, ePicLoad, loadPNG, getDesktop, eListboxPythonMultiContent, eListbox, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER, RT_VALIGN_CENTER, RT_WRAP
from Tools.Directories import pathExists, fileExists, SCOPE_SKIN_IMAGE, resolveFilename
from Tools.LoadPixmap import LoadPixmap
from Tools import Notifications
from Tools.BoundFunction import boundFunction

import urllib, urllib2, re, os, shutil, time, subprocess, datetime, glob, thread
from Tools.Downloader import HTTPProgressDownloader, downloadWithProgress

from twisted.web.client import downloadPage, getPage, error
from twisted.internet import reactor, defer

pname = _("MediaInfo")
pdesc = _("MediaInfo - Stream Download")
pversion = "2.2"

global joblist
joblist = []

global downloadsfile
downloadsfile = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/downloads"

already_open = False
MoviePlayer.originalOpenEventView = MoviePlayer.openEventView

config.plugins.mediainfo = ConfigSubsection()
config.plugins.mediainfo.donemsg = ConfigYesNo(default = True)
config.plugins.mediainfo.dllimit = ConfigInteger(default = 2, limits = (1,10))
config.plugins.mediainfo.premiumize = ConfigYesNo(default = False)
config.plugins.mediainfo.premiumize_user = ConfigText(default = "User",  fixed_size=False)
config.plugins.mediainfo.premiumize_pass = ConfigText(default = "Pass",  fixed_size=False)
config.plugins.mediainfo.savetopath = ConfigText(default = "/media/hdd/movie/",  fixed_size=False)
config.plugins.mediainfo.delunpack = ConfigYesNo(default = True)
config.plugins.mediainfo.share_online = ConfigYesNo(default = False)
config.plugins.mediainfo.share_online_user = ConfigText(default = "user",  fixed_size=False)
config.plugins.mediainfo.share_online_pass = ConfigText(default = "pass",  fixed_size=False)
#config.plugins.mediainfo.otr = ConfigYesNo(default = False)
#config.plugins.mediainfo.otr_user = ConfigText(default = "user",  fixed_size=False)
#config.plugins.mediainfo.otr_pass = ConfigText(default = "pass",  fixed_size=False)

class downloadTask():
	def __init__(self, session, filename, url, hoster):
		self.session = session
		self.filename = filename
		self.url = url
		self.hoster = hoster
		self.end = 100
		self.progress = 0
		self.recvbytes = 0
		self.totalbytes = 0
		self.path = config.plugins.mediainfo.savetopath.value
		self.local = "%s%s" % (self.path, self.filename)
		self.unrar = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unrar"
		self.pwlist = ['Uploadix', 'hd-world.org', 'movie-blog.org', 'ddl-warez', 'serienjunkies.org']
		self.stop_manuell = False
		self.dualPacked = False
		self.dualRarname = None

	def start(self, checkname):
		if self.checkRunningJobs() < int(config.plugins.mediainfo.dllimit.value):
			print "[MediaInfo] Start Download: %s" % checkname
			self.download = downloadWithProgress(self.url, self.local)
			self.download.addProgress(self.http_progress)
			self.download.start().addCallback(self.http_finished).addErrback(self.http_failed)
			return True
		else:
			print "[MediaInfo] Max Download Slots Full %s" % checkname
			return False

	def startWithPremiumize(self, checkname):
		if self.checkRunningJobs() < int(config.plugins.mediainfo.dllimit.value):
			if self.hoster == "share-online" and config.plugins.mediainfo.share_online.value:
				api_url = "http://api.share-online.biz/cgi-bin?q=userdetails&username=%s&password=%s" % (config.plugins.mediainfo.share_online_user.value, config.plugins.mediainfo.share_online_pass.value)
				getPage(api_url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.share_online_Cookies)
			elif self.hoster == "premiumize" and config.plugins.mediainfo.premiumize.value:
				api_url = "https://api.premiumize.me/pm-api/v1.php?method=directdownloadlink&params[login]=%s&params[pass]=%s&params[link]=%s" % (config.plugins.mediainfo.premiumize_user.value, config.plugins.mediainfo.premiumize_pass.value, self.url)
				getPage(api_url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.premiumizeApiData)

	def share_online_Cookies(self, data):
		cookie = re.findall('a=(.*\w+)', data)
		if cookie:
			kecks = "a=%s" % cookie[0]
			keckse = {'cookie': kecks}
			api_url = "http://api.share-online.biz/cgi-bin?q=linkdata&username=%s&password=%s&lid=%s" % (config.plugins.mediainfo.share_online_user.value, config.plugins.mediainfo.share_online_pass.value, self.url)
			getPage(api_url, method='POST', headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.share_online_Data, keckse)

	def share_online_Data(self, data, keckse):
		location = re.findall('URL:.(.*?)\n', data, re.S|re.I)
		if location:
			if self.checkRunningJobs() < int(config.plugins.mediainfo.dllimit.value):
				self.markJobAsDownload(self.filename)
				self.download = downloadWithProgress(location[0], self.local, headers=keckse)
				self.download.addProgress(self.http_progress)
				self.download.start().addCallback(self.http_finished).addErrback(self.http_failed)

	def premiumizeApiData(self, data):
		if self.checkRunningJobs() < int(config.plugins.mediainfo.dllimit.value):
			if re.search('(Hoster could not be parsed from link|login failed)', data, re.S):
				print "[MediaInfo] Start Download: %s" % self.filename
				self.markJobAsDownload(self.filename)
				self.download = downloadWithProgress(self.url, self.local)
				self.download.addProgress(self.http_progress)
				self.download.start().addCallback(self.http_finished).addErrback(self.http_failed)
			else:
				print "[MediaInfo] Start Download with Premiumize.me: %s" % self.filename
				location = re.findall('"location":"(.*?)"', data)
				if location:
					self.markJobAsDownload(self.filename)
					self.download = downloadWithProgress(location[0].replace('\\',''), self.local)
					self.download.addProgress(self.http_progress)
					self.download.start().addCallback(self.http_finished).addErrback(self.http_failed)
				else:
					self.markJobAsError(self.filename)

	def startNextJob(self):
		print "[MediaInfo] Check for Next Download."
		if self.checkRunningJobs() < int(config.plugins.mediainfo.dllimit.value):
			global joblist
			if len(joblist) > 0:
				if config.plugins.mediainfo.premiumize.value:
					for (filename, starttime, status, url, hoster, job) in joblist:
						if status == "Wait" and self.checkRunningJobs() < int(config.plugins.mediainfo.dllimit.value):
							job.startWithPremiumize(filename)
				else:
					for (filename, starttime, status, url, hoster, job) in joblist:
						if status == "Wait" and self.checkRunningJobs() < int(config.plugins.mediainfo.dllimit.value):
							if job.start(filename):
								print "mark as download", filename
								self.markJobAsDownload(filename)

	def checkRunningJobs(self):
		global joblist
		countRuningJobs = 0
		if len(joblist) > 0:
			for (filename, starttime, status, url, hoster, job) in joblist:
				if status == "Download":
					countRuningJobs += 1
		return countRuningJobs

	def markJobAsDownload(self, change_filename):
		joblist_tmp = []
		global joblist
		if len(joblist) > 0:
			for (filename, starttime, status, url, hoster, job) in joblist:
				if filename == change_filename:
					joblist_tmp.append((filename, int(time.time()), "Download", url, hoster, job))
				else:
					joblist_tmp.append((filename, starttime, status, url, hoster, job))
			joblist = joblist_tmp

	def markJobAsFinish(self, change_filename):
		joblist_tmp = []
		global joblist
		if len(joblist) > 0:
			for (filename, starttime, status, url, hoster, job) in joblist:
				if filename == change_filename:
					joblist_tmp.append((filename, starttime, "Complete", url, hoster, job))
				else:
					joblist_tmp.append((filename, starttime, status, url, hoster, job))
			joblist = joblist_tmp

	def markJobAsError(self, change_filename):
		joblist_tmp = []
		global joblist
		if len(joblist) > 0:
			for (filename, starttime, status, url, hoster, job) in joblist:
				if filename == change_filename:
					joblist_tmp.append((filename, starttime, "Error", url, hoster, job))
				else:
					joblist_tmp.append((filename, starttime, status, url, hoster, job))
			joblist = joblist_tmp

	def removeJobsFromJoblist(self, rarname):
		joblist_tmp = []
		global joblist
		if len(joblist) > 0:
			for (filename, starttime, status, url, hoster, job) in joblist:
				if not re.search(rarname, filename, re.I):
					joblist_tmp.append((filename, starttime, status, url, hoster, job))
			joblist = joblist_tmp

	def stop(self):
		self.stop_manuell = True
		if self.download:
			self.download.stop()
	
	def http_progress(self, recvbytes, totalbytes):
		self.progress = int(self.end*recvbytes/float(totalbytes))
		self.recvbytes = recvbytes
		self.totalbytes = totalbytes

	def current_progress(self):
		return [self.recvbytes, self.totalbytes, self.progress]
	
	def http_finished(self, string=""):
		print "[http_finished]" + str(string), self.filename
		self.markJobAsFinish(self.filename)
		self.backupJobs()
		if self.checkRunningJobs() < int(config.plugins.mediainfo.dllimit.value):
			self.startNextJob()
		rarname = self.getRarName(self.filename)
		if rarname is not None:
			if self.checkCompleteDownload(rarname):
				unpack_rarfile = self.getFirstRarFileFromList(rarname)
				if unpack_rarfile is not None:
					self.unpackRelease(unpack_rarfile, True)
		else:
			#if self.otrkey(self.filename):
			#	if config.plugins.mediainfo.otr.value:
			#		print "otr true"
			#		self.decryptOtrkey(self.filename)
			#	else:
			#		message = self.session.open(MessageBox, _("Otr ist in den Einstellungen nicht aktiviert."), MessageBox.TYPE_INFO, timeout=4)
			if config.plugins.mediainfo.donemsg.value:
				message = self.session.open(MessageBox, _("Mediainfo: %s Download Complete." % self.filename), MessageBox.TYPE_INFO, timeout=4)

	def http_failed(self, failure_instance=None, error_message=""):
		if error_message == "" and failure_instance is not None:
			error_message = failure_instance.getErrorMessage()
			print "[http_failed] " + error_message
			if not self.stop_manuell:
				self.markJobAsError(self.filename)

#	def otrkey(self, cfilename):
#		if cfilename.endswith('.otrkey'):
#			print "true"
#			return True
#		else:
#			print "false"
#			return False
#
#	def decryptOtrkey(self, otrFilename):
#		cmd = "otrtool -x -e %s -p %s %s -D %s" % (config.plugins.mediainfo.otr_user.value, config.plugins.mediainfo.otr_pass.value, self.path+otrFilename, self.path)
#		print cmd
#		self.container = eConsoleAppContainer()
#		self.container.appClosed.append(boundFunction(self.decryptOtrkeyComplete, otrFilename))
#		self.container.dataAvail.append(boundFunction(self.otrdecryptLog))
#		self.container.execute(cmd)
#
#	def decryptOtrkeyComplete(self, otrFilename, reval):
#		print "[Mediainfo] Otr File decrypted: %s" % otrFilename
#
#	def otrdecryptLog(self, data):
#		print data
#		if re.search('Decrypting and verifying', data):
#			print "[Mediainfo] decrypting started: %s" % self.filename
#		elif re.search('OK checksums from header match', data):
#			print "[Mediainfo] decrypting Complete: %s" % self.filename
#		elif re.search('Ein Account zur E-Mail.*?wurde nicht gefunden', data):
#			print "[Mediainfo] Onlinetvrecorder login daten falsch: %s" % self.filename
#		elif re.search('Sie haben diese Sendung nicht aufgenommen.', data):
#			print "[Mediainfo] Sie haben diese Sendung nicht aufgenommen. Bitte Wishlist erstellen: %s" % self.filename

	def backupJobs(self):
		global downloadsfile
		if len(joblist) > 0:
			if fileExists(downloadsfile):
				download_file = open(downloadsfile, "w")
				for (filename, starttime, status, url, hoster, job) in joblist:
					download_file.write('"%s" "%s" "%s" "%s"\n' % (filename, status, url, hoster))
				download_file.close()
		else:
			download_file = open(downloadsfile, "w").close()

	def checkCompleteDownload(self, rarname):
		global joblist
		countMatchedRarFiles = 0
		countComplete = 0
		for (filename, starttime, status, url, hoster, job) in joblist:
			if re.search(rarname, filename, re.I):
				countMatchedRarFiles += 1
				if status == "Complete":
					countComplete += 1
		if countMatchedRarFiles == countComplete:
			print "[MediaInfo] All Rarfile(s) Complete:", rarname
			return True
		else:
			print "[MediaInfo] All Rarfile(s) NOT Complete:", rarname
			return False

	def getRarName(self, filename):
		if re.search('part(\S+).rar', filename, re.I):
			rarname =  re.compile(".part", re.I).split(filename)
			return rarname[0]
		elif re.search('\.rar', filename, re.I):
			rarname =  re.compile(".rar", re.I).split(filename)
			return rarname[0]
		else:
			return None

	def getFirstRarFileFromList(self, rarname):
		global joblist
		rarlist = []
		for (filename, starttime, status, url, hoster, job) in joblist:
			if re.search(rarname, filename, re.I):
				rarlist.append(filename)
		if len(rarlist) > 0:
			rarlist.sort()
			return rarlist[0]
		else:
			return None

	def unpackRelease(self, rarname, checkDualPacked):
		if len(self.pwlist) > 0:
			self.found = False
			self.pw = self.pwlist.pop()
			print "[MediaInfo] Password from List: %s" % self.pw
			cmd = "%s e -p%s -kb %s%s -o+ %s" % (self.unrar, self.pw, self.path, rarname, self.path)
			print cmd
			self.container = eConsoleAppContainer()
			self.container.appClosed.append(boundFunction(self.unrarComplete, rarname))
			if checkDualPacked:
				self.container.dataAvail.append(boundFunction(self.unrarLog, True))
			else:
				self.container.dataAvail.append(boundFunction(self.unrarLog, False))
			self.container.execute(cmd)
		else:
			print "[MediaInfo] No Password matched from PWList !"

	def unrarComplete(self, rarname, reval):
		print "[MediaInfo] Unrar Complete - FOUND PW:", self.found
		self.container.kill()
		if not self.found:
			self.unpackRelease(rarname, True)
		else:
			rarname_mark = self.getRarName(rarname)
			if self.dualPacked and self.dualRarname is not None:
				self.rarname_mark_save = self.getRarName(rarname)
				self.dualPacked = False
				self.unpackRelease(self.dualRarname, False)
			elif rarname_mark is not None:
				print "[MediaInfo] Delete RarFile(s) from Joblist ( %s )" % rarname_mark
				message = self.session.open(MessageBox, _("Mediainfo: %s Unpacked." % rarname), MessageBox.TYPE_INFO, timeout=4)
				self.removeJobsFromJoblist(rarname_mark)
				self.removeRarFiles(rarname_mark)
			elif self.rarname_mark_save is not None:
				print "[MediaInfo] Delete RarFile(s) from Joblist ( %s )" % self.rarname_mark_save
				message = self.session.open(MessageBox, _("Mediainfo: %s Unpacked." % rarname), MessageBox.TYPE_INFO, timeout=4)
				self.removeJobsFromJoblist(self.rarname_mark_save)
				self.removeRarFiles(self.rarname_mark_save)

	def unrarLog(self, checkForDualPacked, data):
		print data
		if checkForDualPacked:
			if re.search('\.r00', data):
				dualRarname = re.findall('([a-zA-z0-9_.-]+\.r00)', data)
				if dualRarname:
					self.dualPacked = True
					self.dualRarname = dualRarname[0]
					self.pwlist = self.pwlist = ['Uploadix', 'hd-world.org', 'movie-blog.org', 'ddl-warez', 'serienjunkies.org']
					print "[MediaInfo] Dual Packed: %s" %  self.dualRarname

		if re.search('wrong password', data):
			print "[MediaInfo] Password Missmatch !!! -> %s" % self.pw
			self.found = False
		elif re.search('All OK', data):
			print "[MediaInfo] Password Correct !!! -> %s" % self.pw
			self.found = True

	def removeRarFiles(self, rarname):
		# cleanup bad files
		filelist = glob.glob("%s*" % config.plugins.mediainfo.savetopath.value)
		for file in filelist:
			if file.endswith(('.nfo', '.html', '.url', '.txt')):
				print "[MediaInfo] Remove file(s): %s" % file
				os.remove(file)

		# del unpacked rar files
		if config.plugins.mediainfo.delunpack.value:
			filelist = glob.glob("%s%s.part*" % (config.plugins.mediainfo.savetopath.value, rarname))
			for file in filelist:
				print "[MediaInfo] Remove file(s): %s" % file
				os.remove(file)

class mediaInfoConfigScreen(Screen, ConfigListScreen):
	skin = 	"""
		<screen name="MediaInfo" title="MediaInfo" position="190,35" size="900,655" flags="wfNoBorder">
		<eLabel position="0,0" size="900,655" zPosition="-15" backgroundColor="#20000000" transparent="0" />
		<widget name="head" position="0,0" size="900,45" backgroundColor="#00aaaaaa" transparent="0" zPosition="5" foregroundColor="#00000000" font="Regular;30" halign="center" valign="center" />
		<widget name="config" position="20,50" size="860,325" transparent="1" scrollbarMode="showOnDemand" />
		<widget name="check" position="20,350" size="860,250" font="Regular;20" transparent="1" zPosition="5" valign="top" halign="left" />

		<eLabel position="0,605" size="220,50" zPosition="-10" backgroundColor="#18101319" transparent="0" />
		<eLabel position="225,605" size="220,50" zPosition="-10" backgroundColor="#18101319" transparent="0" />
		<eLabel position="450,605" size="220,50" zPosition="-10" backgroundColor="#18101319" transparent="0" />
		<eLabel position="675,605" size="225,50" zPosition="-10" backgroundColor="#18101319" transparent="0" />
		
		<eLabel position="0,645" size="220,5" zPosition="-10" backgroundColor="#20f23d21" />
		<eLabel position="225,645" size="220,5" zPosition="-10" backgroundColor="#20389416" />
		<eLabel position="450,645" size="220,5" zPosition="-10" backgroundColor="#20e6dd2b" />
		<eLabel position="675,645" size="225,5" zPosition="-10" backgroundColor="#200064c7" />

		<widget name="key_red" position="0,615" size="220,25" zPosition="1" font="Regular;20" halign="center" foregroundColor="foreground" backgroundColor="#18101319" transparent="0" />
		<widget name="key_green" position="225,615" size="220,25" zPosition="1" font="Regular;20" halign="center" foregroundColor="foreground" backgroundColor="#18101319" transparent="0" />
		<widget name="key_yellow" position="450,615" size="220,25" zPosition="1" font="Regular;20" halign="center" foregroundColor="foreground" backgroundColor="#18101319" transparent="0" />
		<widget name="key_blue" position="675,615" size="220,25" zPosition="1" font="Regular;20" halign="center" foregroundColor="foreground" backgroundColor="#18101319" transparent="0" />
	</screen>"""

	def __init__(self, session):
		Screen.__init__(self, session)
		self.session = session

		self["actions"] = ActionMap(["HelpActions", "OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions", "EPGSelectActions", "KeyboardInputActions", "SerienRecorderActions"], {
			"ok"	:	self.ok,
			"cancel":	self.cancel,
			"red"	:	self.cancel,
			"green"	:	self.save,
			"yellow":	self.checkAccounts,
			"left"	:	self.keyLeft,
			"right"	:	self.keyRight
		}, -1)

		self['head'] = Label(_("Settings:"))
		self['key_red'] = Label(_("Cancel"))
		self['key_green'] = Label("Save")
		self['key_yellow'] = Label("Hoster Status")
		self['key_blue'] = Label("")
		self["check"] = ScrollLabel()

		self.log = ""
		self.list = []
		self.createConfigList()
		ConfigListScreen.__init__(self, self.list)
		self.onLayoutFinish.append(self.checkAccounts)

	def createConfigList(self):
		self.setTitle(pname + " (" + pversion + ")")
		self.list = []
		self.list.append(getConfigListEntry(_("Save Downloads to:"), config.plugins.mediainfo.savetopath))
		self.list.append(getConfigListEntry(_("Show 'Download Complete' Message:"), config.plugins.mediainfo.donemsg))
		self.list.append(getConfigListEntry(_("Parallel Downloads:"), config.plugins.mediainfo.dllimit))
		self.list.append(getConfigListEntry(_("Use Premiumize.me:"), config.plugins.mediainfo.premiumize))
		if config.plugins.mediainfo.premiumize.value:
			self.list.append(getConfigListEntry(_("    Premiumize.me Username:"), config.plugins.mediainfo.premiumize_user))
			self.list.append(getConfigListEntry(_("    Premiumize.me Password:"), config.plugins.mediainfo.premiumize_pass))
		self.list.append(getConfigListEntry(_("Use Share-Online.biz:"), config.plugins.mediainfo.share_online))
		if config.plugins.mediainfo.share_online.value:
			self.list.append(getConfigListEntry(_("    Share-Online.biz Username:"), config.plugins.mediainfo.share_online_user))
			self.list.append(getConfigListEntry(_("    Share-Online.biz Password:"), config.plugins.mediainfo.share_online_pass))
		#self.list.append(getConfigListEntry(_("Use Onlinetvrecorder.com for decrypt .otrkey file(s):"), config.plugins.mediainfo.otr))
		#if config.plugins.mediainfo.otr.value:
		#	self.list.append(getConfigListEntry(_("    Onlinetvrecorder.com Username:"), config.plugins.mediainfo.otr_user))
		#	self.list.append(getConfigListEntry(_("    Onlinetvrecorder.com: Password"), config.plugins.mediainfo.otr_pass))

	def changedEntry(self):
		self.createConfigList()
		self["config"].setList(self.list)

	def checkAccounts(self):
		self.log = ""
		sl = self["check"]
		sl.instance.setZPosition(1)
		if config.plugins.mediainfo.premiumize.value:
			api_url = "https://api.premiumize.me/pm-api/v1.php?method=accountstatus&params[login]=%s&params[pass]=%s" % (config.plugins.mediainfo.premiumize_user.value, config.plugins.mediainfo.premiumize_pass.value)
			getPage(api_url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.checkPremiumize)
		else:
			self.writeLogSreen("Hoster Premiumize.me ist disabled.")

		if config.plugins.mediainfo.share_online.value:
			api_url = "http://api.share-online.biz/cgi-bin?q=userdetails&aux=traffic&username=%s&password=%s" % (config.plugins.mediainfo.share_online_user.value, config.plugins.mediainfo.share_online_pass.value)
			getPage(api_url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.checkShareOnline)
		else:
			self.writeLogSreen("Hoster Share-Online.biz ist disabled.")

	def checkPremiumize(self, data):
		premiumizeStatus = ""
		login = re.findall('"statusmessage":"(.*?)"', data)
		if login:
			if re.match('.*?OK', login[0]):
				self.writeLogSreen("Login to: Premiumize.me - OK")
				status = re.findall('"type":"(.*?)"\,"expires":(.*?)\,".*?"trafficleft_gigabytes":(\d+)', data)
				if status:
					(type, expires, left) = status[0]
					zeit = datetime.datetime.fromtimestamp(int(expires)).strftime('%d-%m-%Y %H:%M:%S')
					premiumizeStatus = "Status: Premiumize.me %s - Trafficleft: %s GB - Expired: %s" % (type, int(left), zeit)
					self.writeLogSreen(premiumizeStatus)
			else:
				self.writeLogSreen("Login to: Premiumize.me - FAiLED")

	def checkShareOnline(self, data):
		status = re.findall('group=(.*?)\n.*?expire_date=(.*?)\n', data, re.S)
		if status:
			self.writeLogSreen("Login to: Share-Online.biz - OK")
			(type, expires) = status[0]
			zeit = datetime.datetime.fromtimestamp(int(expires)).strftime('%d-%m-%Y %H:%M:%S')
			shareOnlineStatus = "Status: Share-Online.biz %s - Expired: %s" % (type, zeit)
			self.writeLogSreen(shareOnlineStatus)
		else:
			self.writeLogSreen("Login to: Share-Online.biz - FAiLED")

	def writeLogSreen(self, txt):
		self.log += txt+"\n"
		self["check"].setText(self.log)

	def ok(self):
		ConfigListScreen.keyOK(self)
		if self['config'].getCurrent()[1] == config.plugins.mediainfo.savetopath:
			self.session.openWithCallback(self.selectedMediaFile, mediaInfoFolderScreen, config.plugins.mediainfo.savetopath.value)

	def selectedMediaFile(self, res):
		if res is not None:
			config.plugins.mediainfo.savetopath.value = res
			config.plugins.mediainfo.savetopath.save()
			configfile.save()
			self.changedEntry()

	def keyLeft(self):
		ConfigListScreen.keyLeft(self)
		self.changedEntry()

	def keyRight(self):
		ConfigListScreen.keyRight(self)
		self.changedEntry()

	def save(self):
		config.plugins.mediainfo.savetopath.save()
		config.plugins.mediainfo.donemsg.save()
		config.plugins.mediainfo.dllimit.save()
		config.plugins.mediainfo.premiumize.save()
		config.plugins.mediainfo.premiumize_user.save()
		config.plugins.mediainfo.premiumize_pass.save()
		config.plugins.mediainfo.share_online.save()
		config.plugins.mediainfo.share_online_user.save()
		config.plugins.mediainfo.share_online_pass.save()
		#config.plugins.mediainfo.otr.save()
		#config.plugins.mediainfo.otr_user.save()
		#config.plugins.mediainfo.otr_pass.save()
		configfile.save()
		self.close()

	def cancel(self):
		self.close()

class mediaInfoFolderScreen(Screen):
	skin = """
		<screen position="center,center" size="650,400" title=" " flags="wfNoBorder">
			<widget name="media" position="10,10" size="540,30" valign="top" font="Regular;22" />
			<widget name="folderlist" position="10,45" zPosition="1" size="540,300" scrollbarMode="showOnDemand"/>
			<ePixmap position="10,370" size="260,25" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/pic/button_red.png" alphatest="on" />
			<ePixmap position="210,370" size="260,25" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/pic/button_green.png" alphatest="on" />
			<widget render="Label" source="key_red" position="40,372" size="100,20" valign="center" halign="left" zPosition="2" font="Regular;18" foregroundColor="white" />
			<widget render="Label" source="key_green" position="240,372" size="70,20" valign="center" halign="left" zPosition="2" font="Regular;18" foregroundColor="white" />
		</screen>
		"""

	def __init__(self, session, initDir, plugin_path = None):
		Screen.__init__(self, session)
		
		if not os.path.isdir(initDir):
			initDir = "/media/hdd/movie/"

		self["folderlist"] = FileList(initDir, inhibitMounts = False, inhibitDirs = False, showMountpoints = False, showFiles = False)
		self["media"] = Label()
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions"],
		{
			"back": self.cancel,
			"left": self.left,
			"right": self.right,
			"up": self.up,
			"down": self.down,
			"ok": self.ok,
			"green": self.green,
			"red": self.cancel
		}, -1)
		self.title=_("Choose Download folder")
		try:
			self["title"] = StaticText(self.title)
		except:
			print 'self["title"] was not found in skin'	
		self["key_red"] = StaticText(_("Cancel"))
		self["key_green"] = StaticText(_("Ok"))

	def cancel(self):
		self.close(None)

	def green(self):
		directory = self["folderlist"].getSelection()[0]
		if (directory.endswith("/")):
			self.fullpath = self["folderlist"].getSelection()[0]
		else:
			self.fullpath = self["folderlist"].getSelection()[0] + "/"
	  	self.close(self.fullpath)

	def up(self):
		self["folderlist"].up()
		self.updateFile()

	def down(self):
		self["folderlist"].down()
		self.updateFile()

	def left(self):
		self["folderlist"].pageUp()
		self.updateFile()

	def right(self):
		self["folderlist"].pageDown()
		self.updateFile()

	def ok(self):
		if self["folderlist"].canDescent():
			self["folderlist"].descent()
			self.updateFile()

	def updateFile(self):
		currFolder = self["folderlist"].getSelection()[0]
		self["media"].setText(currFolder)

def ListEntry(entry):
	(filename, status, progress, dlspeed, currentSizeMB, totalMB) = entry
	if status == "Download":
		mbinfo = "%s mb/ %s mb" % (str(currentSizeMB), str(totalMB))
		dlinfo = "%s" % dlspeed
		return [entry,
			(eListboxPythonMultiContent.TYPE_TEXT, 20, 0, 480, 50, 0, RT_HALIGN_LEFT | RT_WRAP, filename),
			(eListboxPythonMultiContent.TYPE_PROGRESS, 530, 5, 160, 15, int(progress)),
			(eListboxPythonMultiContent.TYPE_TEXT, 705, 0, 50, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, str(progress)+"%"),
			(eListboxPythonMultiContent.TYPE_TEXT, 770, 0, 150, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, status),
			(eListboxPythonMultiContent.TYPE_TEXT, 530, 25, 210, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, mbinfo),
			(eListboxPythonMultiContent.TYPE_TEXT, 770, 25, 150, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, dlinfo),
			]
	elif status == "Complete":
		return [entry,
			(eListboxPythonMultiContent.TYPE_TEXT, 20, 0, 480, 50, 0, RT_HALIGN_LEFT | RT_WRAP, filename),
			(eListboxPythonMultiContent.TYPE_PROGRESS, 530, 5, 160, 15, 100),
			(eListboxPythonMultiContent.TYPE_TEXT, 705, 0, 50, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, "100%"),
			(eListboxPythonMultiContent.TYPE_TEXT, 770, 0, 150, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, status),
			]
	else:
		return [entry,
			(eListboxPythonMultiContent.TYPE_TEXT, 20, 0, 480, 50, 0, RT_HALIGN_LEFT | RT_WRAP, filename),
			(eListboxPythonMultiContent.TYPE_PROGRESS, 530, 5, 160, 15, 0),
			(eListboxPythonMultiContent.TYPE_TEXT, 705, 0, 50, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, "0%"),
			(eListboxPythonMultiContent.TYPE_TEXT, 770, 0, 150, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, status),
			]


class mediaInfo(Screen):
	skin = 	"""
		<screen name="MediaInfo" title="MediaInfo" position="190,35" size="900,655" flags="wfNoBorder">
		<eLabel position="0,0" size="900,655" zPosition="-15" backgroundColor="#20000000" transparent="0" />
		<widget name="info" position="0,0" size="900,45" backgroundColor="#00aaaaaa" transparent="0" zPosition="5" foregroundColor="#00000000" font="Regular;24" halign="center" valign="center" />
		<widget name="head" position="0,50" size="900,45" backgroundColor="#00aaaaaa" transparent="0" zPosition="5" foregroundColor="#00000000" font="Regular;30" halign="center" valign="center" />
		<widget name="downloadList" position="0,100" size="900,500" backgroundColor="#00101214" scrollbarMode="showOnDemand" transparent="1" />
		
		<eLabel position="0,605" size="220,50" zPosition="-10" backgroundColor="#18101319" transparent="0" />
		<eLabel position="225,605" size="220,50" zPosition="-10" backgroundColor="#18101319" transparent="0" />
		<eLabel position="450,605" size="220,50" zPosition="-10" backgroundColor="#18101319" transparent="0" />
		<eLabel position="675,605" size="225,50" zPosition="-10" backgroundColor="#18101319" transparent="0" />
		
		<eLabel position="0,645" size="220,5" zPosition="-10" backgroundColor="#20f23d21" />
		<eLabel position="225,645" size="220,5" zPosition="-10" backgroundColor="#20389416" />
		<eLabel position="450,645" size="220,5" zPosition="-10" backgroundColor="#20e6dd2b" />
		<eLabel position="675,645" size="225,5" zPosition="-10" backgroundColor="#200064c7" />

		<widget name="key_red" position="0,615" size="220,25" zPosition="1" font="Regular;20" halign="center" foregroundColor="foreground" backgroundColor="#18101319" transparent="0" />
		<widget name="key_green" position="225,615" size="220,25" zPosition="1" font="Regular;20" halign="center" foregroundColor="foreground" backgroundColor="#18101319" transparent="0" />
		<widget name="key_yellow" position="450,615" size="220,25" zPosition="1" font="Regular;20" halign="center" foregroundColor="foreground" backgroundColor="#18101319" transparent="0" />
		<widget name="key_blue" position="675,615" size="220,25" zPosition="1" font="Regular;20" halign="center" foregroundColor="foreground" backgroundColor="#18101319" transparent="0" />
	</screen>"""

	def __init__(self, session, livestreaming):
		Screen.__init__(self, session)
		self.session = session
		self.livestreaming = livestreaming

		self['info'] = Label("Load Stream Info..")
		self['head'] = Label("Downloads")
		self['key_red'] = Label("Remove")
		self['key_green'] = Label("Download")
		self['key_yellow'] = Label("Start/Stop")
		self['key_blue'] = Label("Setup")

		global joblist
		self.dllist = []
		self.channelMenuList = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		self.channelMenuList.l.setFont(0, gFont('Regular', 22))
		self.channelMenuList.l.setItemHeight(50)
		self['downloadList'] = self.channelMenuList

		self["actions"] = ActionMap(["WizardActions"],
		{
			"back": self.exit,
		}, -1)
		
		self["actions"]  = ActionMap(["OkCancelActions", "ShortcutActions", "EPGSelectActions", "WizardActions", "ColorActions", "NumberActions", "MenuActions", "MoviePlayerActions", "InfobarSeekActions"], {
			"ok"	:	self.exit,
			"info"	:	self.exit,
			"cancel":	self.exit,
			"red"	:	self.jobRemove,
			"green"	:	self.jobStart,
			"yellow":	self.jobCheck,
			"blue"	:	self.mediaInfoSetup,
			"up"	:	self.keyUp,
			"down"	:	self.keyDown,
			"left"	:	self.keyLeft,
			"right"	:	self.keyRight
		}, -1)

		self.refreshTimer = eTimer()
		self.setTitle(pname + " (" + pversion + ")")
		if self.livestreaming:
			self.refreshTimer.callback.append(self.showJobs)
			self.refreshTimer.callback.append(self.streamInfo)
			self.getPremiumizeStatus(True)
		else:
			self.refreshTimer.callback.append(self.showJobs)
			self.getPremiumizeStatus(False)
		self.refreshTimer.start(1500)
		self.onLayoutFinish.append(self.showJobs)

	def getTitle(self):
		exist = self['downloadList'].getCurrent()
		if exist == None:
			return
		filename = self['downloadList'].getCurrent()[0][0]
		self.title = filename

	def streamInfo(self):
		service = self.session.nav.getCurrentService()
		bufferInfo = service.streamed().getBufferCharge()
		pname_text = service.info().getName()
		url_text = self.session.nav.getCurrentlyPlayingServiceReference().getPath()
		if bufferInfo != None: 
			if bufferInfo[2] != 0:
				self.bufferSeconds = bufferInfo[4] / bufferInfo[2] #buffer size / avgOutRate
			else:
				self.bufferSeconds = 0
			self.bufferPercent = bufferInfo[0]
			self.bufferSecondsLeft = self.bufferSeconds * self.bufferPercent / 100
			self["info"].setText("Stream %s - Bitrate: %s - Buffer: %s filled (%s sec.)" % (self.formatKB(bufferInfo[1]), self.formatKBits(bufferInfo[2]), self.bufferPercent, self.bufferSecondsLeft))
			
	def getPremiumizeStatus(self, showTitle=False):
		if config.plugins.mediainfo.premiumize.value:
			api_url = "https://api.premiumize.me/pm-api/v1.php?method=accountstatus&params[login]=%s&params[pass]=%s" % (config.plugins.mediainfo.premiumize_user.value, config.plugins.mediainfo.premiumize_pass.value)
			getPage(api_url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.getPremiumizeStatusData, showTitle)
		else:
			if not showTitle:
				self['info'].setText("Premiumize: Disabled")
			else:
				self.title = "Premiumize: Disabled"
		
	def getPremiumizeStatusData(self, data, showTitle):
		premiumizeStatus = ""
		login = re.findall('"statusmessage":"(.*?)"', data)
		if login:
			if re.match('.*?OK', login[0]):
				print "[MediaInfo] Premiumize.me login = True"
				status = re.findall('"type":"(.*?)"\,"expires":(.*?)\,".*?"trafficleft_gigabytes":(\d+)', data)
				if status:
					(type, expires, left) = status[0]
					zeit = datetime.datetime.fromtimestamp(int(expires)).strftime('%d-%m-%Y %H:%M:%S')
					premiumizeStatus = "Premiumize: %s - Trafficleft: %s GB - Expired: %s" % (type, int(left), zeit)
			else:
				premiumizeStatus = "Premiumize: Login Failed"
				print "[MediaInfo] Premiumize.me login = False."
				config.plugins.mediainfo.premiumize.value = False
				config.plugins.mediainfo.premiumize.save()
				configfile.save()
		if not showTitle:
			self['info'].setText(premiumizeStatus)
		else:
			self.title = premiumizeStatus

	def sendLink(self, filename, url):
		self.addJob = downloadTask(self.session, filename, url, "stream")
		global joblist
		joblist.append((filename, int(time.time()), "Wait", url, "stream", self.addJob))
		self.jobDownload(filename)
		self.backupJobs()

	def sendLinks(self, linklist):
		if len(linklist) > 0:
			loadlinks = []
			loadlinks_share_online = []
			for url in linklist:
				if re.search('ul.to', url):
					if re.search('ul.to/.*?/', url, re.S|re.I):
						id = re.findall('ul.to/(.*?)/', url, re.S|re.I)
					elif re.search('ul.to/.*?', url, re.S|re.I):
						id = re.findall('ul.to/(.*?)$', url, re.S|re.I)
					status_url = 'http://uploaded.net/file/%s/status' % id[0]
					loadlinks.append((url, status_url))

				elif re.search('uploaded.(net|to)', url, re.S|re.I):
					if re.search('uploaded.(net|to)/file/.*?/', url, re.S|re.I):
						id = re.findall('uploaded.*?/file/(.*?)/', url, re.S|re.I)
					elif re.search('uploaded.(net|to)/file/.*?', url, re.S|re.I):
						id = re.findall('uploaded.*?/file/(.*?)$', url, re.S|re.I)
					status_url = 'http://uploaded.net/file/%s/status' % id[0]
					loadlinks.append((url, status_url))
				
				elif re.search('oboom.com', url, re.S|re.I):
					if re.search('oboom.com/.*?/', url, re.S|re.I):
						if re.search('#', url, re.S|re.I):
							id = re.findall('#(.*?)/', url, re.S|re.I)
						else:
							id = re.findall('oboom.com/(.*?)/', url, re.S|re.I)
						if id:
							status_url = "https://api.oboom.com/1.0/info?items="+id[0]
							loadlinks.append((url, status_url))
					else:
						if re.search('#', url, re.S|re.I):
							id = re.findall('#(.*?)$', url, re.S|re.I)
						else:
							id = re.findall('oboom.com/(.*?)$', url, re.S|re.I)
						if id:
							status_url = "https://api.oboom.com/1.0/info?items="+id[0]
							loadlinks.append((url, status_url))
				elif re.search('firedrive.com/file', url, re.S|re.I):
					loadlinks.append((url, status_url))

				elif re.search('share-online.biz/dl/', url, re.S|re.I):
					if re.search('share-online.biz/dl/.*?/', url, re.S|re.I):
						id = re.findall('share-online.biz/dl/(.*?)/', url, re.S|re.I)
					else:
						id = re.findall('share-online.biz/dl/(.*?)$', url, re.S|re.I)
					if id:
						post_data = urllib.urlencode({'links': id[0]})
						loadlinks_share_online.append((url, id[0], "http://api.share-online.biz/linkcheck.php", post_data))

			if len(loadlinks) > 0:
				ds = defer.DeferredSemaphore(tokens=1)
				downloads = [ds.run(self.download, status_url).addCallback(self.getStatusInfo, url).addErrback(self.downloadError) for url, status_url in loadlinks]
				finished = defer.DeferredList(downloads).addErrback(self.dataError)
			elif len(loadlinks_share_online) > 0:
				ds = defer.DeferredSemaphore(tokens=1)
				downloads = [ds.run(self.download_share_online, post_url, post_data).addCallback(self.getStatusInfo_share_online, id).addErrback(self.downloadError) for url, id, post_url, post_data in loadlinks_share_online]
				finished = defer.DeferredList(downloads).addErrback(self.dataError)

	def download(self, url):
		return getPage(url)

	def download_share_online(self, post_url, post_data):
		return getPage(post_url, method='POST', postdata=post_data)

	def downloadError(self, error):
		print error

	def getStatusInfo(self, data, url):
		if re.search('firedrive.com', data):
			filename = re.findall('<b>Name:</b>.(.*?).<br>', data)
		else:
			filename = re.findall('([a-zA-z0-9_.-]+\.rar)', data)
		if filename:
			self.addJob = downloadTask(self.session, filename[0], url, "premiumize")
			global joblist
			joblist.append((filename[0], int(time.time()), "Wait", url, "premiumize", self.addJob))
			if config.plugins.mediainfo.premiumize.value:
				self.jobDownload(filename[0])

	def getStatusInfo_share_online(self, data, id):
		if re.search(';OK;', data):
			filename = re.findall(';OK;(.*?);', data)
			if filename:
				self.addJob = downloadTask(self.session, filename[0], id, "share-online")
				global joblist
				joblist.append((filename[0], int(time.time()), "Wait", id, "share-online", self.addJob))
				if config.plugins.mediainfo.share_online.value:
					self.jobDownload(filename[0])

	def jobStart(self):
		service = self.session.nav.getCurrentService()
		filename = service.info().getName()
		url = self.session.nav.getCurrentlyPlayingServiceReference().getPath()
		filename = ''.join(re.split(r'[.;:!&?,]', filename))
		quessFileType = os.path.splitext(url)[1][1:]
		if re.search('(\.avi|\.mp4|\.ts|\.mp3|\.mpg|\.mpeg)', quessFileType, re.I):
			filetype = quessFileType
		else:
			filetype = ".mp4"
		filename = "%s%s" % (filename.replace(' ','_'), filetype)
		
		if not any(filename in job for job in joblist):
			if re.match('.*?http', url, re.S):
				try:
					req = urllib2.Request(url)
					res = urllib2.urlopen(req)
					url = res.geturl()
					print "[Download] added: %s - %s" % (filename, url)
					self.addJob = downloadTask(self.session, filename, url, "stream")
					global joblist
					joblist.append((filename, int(time.time()), "Wait", url, "stream", self.addJob))
					self.jobDownload(filename)
					self.backupJobs()
				except urllib2.HTTPError, error:
					print error
					message = self.session.open(MessageBox, ("Fehler: %s" % error), MessageBox.TYPE_INFO, timeout=3)
				except urllib2.URLError, error:
					print error.reason
					message = self.session.open(MessageBox, ("Fehler: %s" % error.reason), MessageBox.TYPE_INFO, timeout=3)
			else:
				message = self.session.open(MessageBox, ("No rtmp download support, only http protocol."), MessageBox.TYPE_INFO, timeout=3)
		else:
			print "[MediaInfo] dupe: %s" % filename
			
	def showJobs(self):
		self.taskList = []
		global joblist
		showDownload = 0
		showWait = 0
		showComplete = 0
		showError = 0
		self.dllist = []
		self.waitlist = []
		self.completelist = []
		self.errorlist = []
		for (filename, starttime, status, url, hoster, job) in joblist:
			if status == "Download":
				showDownload += 1
				(recvbytes, totalbytes, progress) = job.current_progress()
				currentSizeMB = int(recvbytes/1024/1024)
				totalMB = int(totalbytes/1024/1024)
				dlspeed = self.calcDnSpeed(int(starttime), currentSizeMB, totalMB)
				self.dllist.append((filename, status, progress, dlspeed, currentSizeMB, totalMB))
			elif status == "Wait":
				showWait += 1
				self.waitlist.append((filename, status, 0, 0, 0, 0))
			elif status == "Complete":
				showComplete += 1
				self.completelist.append((filename, status, 0, 0, 0, 0))
			elif status == "Error":
				showError += 1
				self.errorlist.append((filename, status, 0, 0, 0, 0))
		info = "Downloads: %s / %s (%s) - Wait: %s - Complete: %s - Error: %s" % (str(showDownload), str(len(joblist)), str(config.plugins.mediainfo.dllimit.value), str(showWait), str(showComplete), str(showError))
		self["head"].setText(info)
		self.taskList = self.dllist + self.waitlist + self.completelist + self.errorlist
		self.channelMenuList.setList(map(ListEntry, self.taskList))
			
	def calcDnSpeed(self, starttime, currentSizeMB, totalMB):
		endtime = int(time.time())
		runtime = endtime - int(starttime)
		if runtime == 0:
			runtime = 1
		if currentSizeMB == 0:
			currentSizeMB = 1
		dlspeed = (currentSizeMB * 1024) / runtime
		resttime = (((int(totalMB) - currentSizeMB) * 1024) / (currentSizeMB * 1024)) * runtime
		if dlspeed > 1024:
			dlspeed = "%.2f mb/s" % (float(dlspeed) / 1024)
		else:
			dlspeed = "%s kb/s" % dlspeed
		return dlspeed

	### job changes
	def jobCheck(self):
		exist = self['downloadList'].getCurrent()
		if exist == None:
			return
		filename = self['downloadList'].getCurrent()[0][0]
		status = self['downloadList'].getCurrent()[0][1]
		if status == "Download":
			self.jobStop(filename, False)
		else:
			self.jobDownload(filename)

	def jobDownload(self, change_filename):
		#joblist_tmp = []
		global joblist
		for (filename, starttime, status, url, hoster, job) in joblist:
			if filename == change_filename:
				if config.plugins.mediainfo.premiumize.value and hoster == "premiumize":
					job.startWithPremiumize(filename)
				elif config.plugins.mediainfo.share_online.value and hoster == "share-online":
					job.startWithPremiumize(filename)
				elif hoster == "stream":
					if job.start(filename):
						job.markJobAsDownload(filename)
		self.showJobs()

	def jobStop(self, change_filename, remove=False):
		joblist_tmp = []
		global joblist
		for (filename, starttime, status, url, hoster, job) in joblist:
			if filename == change_filename:
				job.stop()
				if not remove:
					joblist_tmp.append((filename, starttime, "Wait", url, hoster, job))
			else:
				joblist_tmp.append((filename, starttime, status, url, hoster, job))
		joblist = joblist_tmp
		self.showJobs()

	def jobRemove(self):
		exist = self['downloadList'].getCurrent()
		if exist == None:
			return
		check_filename = self['downloadList'].getCurrent()[0][0]
		check_status = self['downloadList'].getCurrent()[0][1]
		if check_status == "Download":
			self.jobStop(check_filename, True)
			self.showJobs()
		elif check_status == "Wait" or "Complete" or "Error":
			joblist_tmp = []
			global joblist
			rarname = self.getRarName(check_filename)
			if rarname is not None:
				for (filename, starttime, status, url, hoster, job) in joblist:
					if not re.search(rarname, filename, re.I):
						joblist_tmp.append((filename, starttime, status, url, hoster, job))
				joblist = joblist_tmp
			else:
				for (filename, starttime, status, url, hoster, job) in joblist:
					if not filename == check_filename:
						joblist_tmp.append((filename, starttime, status, url, hoster, job))
				joblist = joblist_tmp
			self.showJobs()
			self.backupJobs()

	def backupJobs(self):
		global downloadsfile
		if len(joblist) > 0:
			if fileExists(downloadsfile):
				download_file = open(downloadsfile, "w")
				for (filename, starttime, status, url, hoster, job) in joblist:
					download_file.write('"%s" "%s" "%s" "%s"\n' % (filename, status, url, hoster))
				download_file.close()
		else:
			download_file = open(downloadsfile, "w").close()

	def getRarName(self, filename):
		if re.search('part(\S+).rar', filename, re.I):
			rarname =  re.compile(".part", re.I).split(filename)
			return rarname[0]
		else:
			return None

	### formats
	def formatKBits(self, value, ending="Bit/s", roundNumbers=2):
		bits = value * 8
		if bits > (1024*1024):
			return str(round(float(bits)/float(1024*1024),roundNumbers))+" M"+ending
		if bits > 1024:
			return str(round(float(bits)/float(1024),roundNumbers))+" K"+ending
		else:
			return str(bits)+" "+ending
		
	def formatKB(self, value, ending="B", roundNumbers=2):
		byte = value
		if byte > (1024*1024):
			return str(round(float(byte)/float(1024*1024),roundNumbers))+" M"+ending
		if byte > 1024:
			return str(round(float(byte)/float(1024),roundNumbers))+" K"+ending
		else:
			return str(byte)+" "+ending

	def dataError(self, error):
		print error

	### Keys
	def mediaInfoSetup(self):
		self.session.openWithCallback(self.mediaInfoSetupCallback, mediaInfoConfigScreen)

	def mediaInfoSetupCallback(self):
		if self.livestreaming:
			self.getPremiumizeStatus(True)
		else:
			self.getPremiumizeStatus(False)

	def keyLeft(self):
		self['downloadList'].pageUp()
		self.getTitle()

	def keyRight(self):
		self['downloadList'].pageDown()
		self.getTitle()

	def keyUp(self):
		self['downloadList'].up()
		self.getTitle()
		
	def keyDown(self):
		self['downloadList'].down()
		self.getTitle()

	def exit(self):
		already_open = False
		self.close()

def openMoviePlayerEventView(self):
	already_open = False
	if True and not already_open:
		already_open = True
		service = self.session.nav.getCurrentService()
		filename = service.info().getName()
		url = self.session.nav.getCurrentlyPlayingServiceReference().getPath()
		if re.match('.*?http://', url, re.S):
			self.session.open(mediaInfo, True)
		else:
			self.session.open(mediaInfo, False)
	else:
		MoviePlayer.originalOpenEventView(self)

MoviePlayer.openEventView = openMoviePlayerEventView

def autostart(reason, **kwargs):
	global downloadsfile
	if (reason == 0) and (kwargs.has_key("session")):
		session = kwargs["session"]
		session = session
		global joblist
		print "[MediaInfo] READ OLD JOBS !!!"
		if fileExists(downloadsfile):
			dlfile = open(downloadsfile, "r")
			for rawData in dlfile.readlines():
				data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
				if data:
					(filename, status, url, hoster) = data[0]
					addJob = downloadTask(session, filename, url, hoster)
					if status == "Download":
						joblist.append((filename, int(time.time()), "Wait", url, hoster, addJob))
					elif status == "Error":
						joblist.append((filename, int(time.time()), "Wait", url, hoster, addJob))
					else:
						joblist.append((filename, int(time.time()), status, url, hoster, addJob))
		else:
			dlfile = open(downloadsfile, "w").close()

def main(session, **kwargs):
	session.open(mediaInfo, False)
	
def Plugins(**kwargs):
	return [PluginDescriptor(name="MediaInfo", description="Download the Stream", where = [PluginDescriptor.WHERE_PLUGINMENU], icon="plugin.png", fnc=main),
			PluginDescriptor(where=[PluginDescriptor.WHERE_SESSIONSTART], fnc=autostart)]